import { Table } from "typeorm";
import { getDefaultByORM, getTypeByORM, isUUIDPrimary } from "../ormHelper";

export const mission_table = new Table({
  name: "mission",
  columns: [
    { name: "id", ...getTypeByORM("uuid"), ...isUUIDPrimary },
    { name: "title", ...getTypeByORM("varchar") },
    { name: "keyword", ...getTypeByORM("varchar", true), default: getDefaultByORM("null") },
    { name: "createdAt", ...getTypeByORM("datetime", false, 6), default: getDefaultByORM("currentTimestamp") },
  ],
});
