import { Server, Socket } from "socket.io";
import { SocketMap } from "../../storage/socketMap";
import CustomRequestException from "../../exceptions/customRequestException";
import { handleEvent } from "../handleEvent";

export default (io: Server, socket: Socket) => {
  socket.on(
    "join:mission",

    handleEvent(
      { type: "read", section: "operation", module: "mission" },
      async (data: any) => {
        socket.rooms.forEach((room) => {
          if (room !== socket.id && room != "home") {
            socket.leave(room);
          }
        });

        try {
          socket.join(data);
          socket.emit("status-mission:room", { status: "success" });
          // get mission data
          // create yjs sync doc
          // provide yjs sync doc to client
          return {
            type: "package-mission",
            answer: "mission-data by yjs",
          };
        } catch (error) {
          return { type: "status-join:room", answer: { status: "failed", msg: error.message } };
        }
      },
      socket
    )
  );
};
